# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with             jdk6


# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/hibernate-entitymanager/%{version}.GA-brew
%define repodirlib %{repodir}/lib
%define repodirres %{repodir}/resources
%define repodirsrc %{repodir}/src

%define section free
%define hname hibernate-entitymanager

Name:           hibernate3-entitymanager
Version:        3.2.1
Release:        5%{?dist}
Epoch:          0
License:        LGPLv2+
Summary:        Relational persistence and query service
URL:            http://annotations.hibernate.org/
Group:          Database
Source0:        http://prdownloads.sourceforge.net/hibernate/hibernate-entitymanager-3.2.1.GA.tar.gz
Source1:	hibernate-entitymanager-jdstyle.css
Patch1:		hibernate-entitymanager-build_xml.patch
Patch0:		hibernate-entitymanager-common-build_xml.patch
Source2:	hibernate3-entitymanager-component-info.xml
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  java-devel >= 0:1.5
BuildRequires:  ant
BuildRequires:  ant-junit
BuildRequires:  antlr
BuildRequires:  asm
BuildRequires:  cglib
BuildRequires:  dom4j
BuildRequires:  geronimo-jta-1.0.1B-api
BuildRequires:  hibernate3 >= 0:3.2
BuildRequires:  hibernate3-annotations >= 0:3.2.1
BuildRequires:  hibernate3-ejb-persistence-3.0-api >= 0:3.2.1
BuildRequires:  hsqldb
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-logging
BuildRequires:  javassist
BuildRequires:  junit
BuildRequires:  jboss-common
#BuildRequires:  jboss-archive-browsing

Requires:  java >= 0:1.5
# EAP only - The environment will need to provide a compatible hibernate
#Requires:  hibernate3 >= 0:3.2
Requires:  hibernate3-annotations >= 0:3.2.1
Requires:  javassist
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
EJB3 standardizes the basic APIs and the metadata needed for
any object/relational persistence mechanism. Hibernate
EntityManager implements the programming interfaces,
lifecycle rules and packaging archive support as defined by
the EJB3 persistence specification.
Together with Hibernate Annotations, this wrapper implements
a complete (and standalone) EJB3 persistence provider, as
defined by the JSR-220 public final draft, on top of the
mature Hibernate3 core.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:	        Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{hname}-%{version}.GA
find . -name "*.jar" | xargs -t rm
mkdir test_output
cp -p %{SOURCE1} doc/api/jdstyle.css

%patch0 -b .sav
%patch1 -b .sav

%build
build-jar-repository -s -p . \
hibernate3

mkdir jdbc
build-jar-repository -s -p jdbc hsqldb

build-jar-repository -s -p lib \
antlr \
asm/asm \
cglib-nodep \
commons-collections \
commons-logging \
dom4j \
javassist \
jboss-common/jboss-common \
jta \
hibernate3 \
hibernate3-annotations \
hibernate3-ejb-persistence-3.0-api

ant \
	-Dhibernate-core.home=. \
	-Djdk15.home=%{java_home} \
	jar javadoc \
%if %without jdk6
	junitinstrument junit
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p target/%{hname}/%{hname}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && ln -sf %{name}.jar hibernate-entitymanager.jar)

## javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%if %{with_repolib}
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version}.GA-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/hibernate-entitymanager.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_DIR/hibernate-entitymanager-3.2.1.GA/lib/hibernate3-ejb-persistence-3.0-api.jar $RPM_BUILD_ROOT%{repodirlib}/ejb3-persistence.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%doc lgpl.txt
%{_javadir}/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Fri Oct 10 2008 David Walluck <dwalluck@redhat.com> 0:3.2.1-5
- fix build on JDK < 6

* Fri Oct 10 2008 David Walluck <dwalluck@redhat.com> 0:3.2.1-4
- fix repolib

* Fri Oct 10 2008 Yong Yang <yyang@redhat.com> - 0:3.2.1-3
- Support building on jdk6

* Mon Jun 02 2008 Permaine Cheung <pcheung@redhat.com> - 0:3.2.1-2
- First JPP 5 build

* Fri Apr 04 2008 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1jpp.ep1.7
- Add compatible lines for upgraded releated components

* Fri Jan 25 2008 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1jpp.ep1.6
- Add compatible lines for upgraded releated components

* Fri Sep 07 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1jpp.ep1.5
- Relax dependency on hibernate3 core (environment provides it on EAP)

* Fri Aug 24 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1jpp.ep1.4
- Add compatibility to patched annotations

* Fri Aug 10 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.2.1-1jpp.ep1.3
- Add repolib support
- Add hibernate3-ejb-persistence-3.0-api.jar artificially in repolib pkg
  from the build root - HACK

* Fri Aug 10 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.2.1-1jpp.ep1.2
- Add a hibernate-entitymanager.jar link

* Thu Aug 09 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1jpp.ep1.1
- Merge with upstream

* Thu Aug 09 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1jpp
- Update to 3.2.1.GA
- Add missing BRs for hsqldb, junit and ant-junit

* Wed Aug 02 2006 Fernando Nasser <fnasser@redhat.com> - 0:3.2.0-0.cr1.2jpp_1rh
- First Red Hat build

* Tue Aug 02 2006 Ralph Apel <r.apel at r-apel.de> - 0:3.2.0-0.cr1.2jpp
- Use rpm packaged hibernate3 and dependency libraries
- Activate unit tests

* Wed Jun 21 2006 Ralph Apel <r.apel at r-apel.de> - 0:3.2.0-0.cr1.1jpp
- First JPP-5.0 release
